
Redmine - Defect #20841

Bare URLs in Markdown don't have "external" class

2015-09-26 05:49 - Go MAEDA

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Text formatting Estimated time: 0.00 hour

Target version:    

Resolution: Wont fix Affected version:  

Description

expected:

http://www.redmine.org/ =>

<a href="http://www.redmine.org/" class="external">http://www.redmine.org/</a>

actual:

http://www.redmine.org/ =>

<a href="http://www.redmine.org/">http://www.redmine.org/</a>

No problem in Textile formatter. Probably all versions that support Markdown are affected.

Related issues:

Related to Redmine - Feature #32424: CommonMark Markdown Text Formatting Closed

Has duplicate Redmine - Feature #39003: Add css class to external links in ma... Closed

Blocks Redmine - Feature #1151: Open Links in New-Window New 2008-05-01

History

#1 - 2015-09-26 05:54 - Go MAEDA

- Blocks Feature #1151: Open Links in New-Window added

#2 - 2018-07-15 04:42 - Go MAEDA

- Target version set to Candidate for next minor release

The following patch fixes this issue.

Index: lib/redmine/wiki_formatting/markdown/formatter.rb

===================================================================

--- lib/redmine/wiki_formatting/markdown/formatter.rb    (revision 17445)

+++ lib/redmine/wiki_formatting/markdown/formatter.rb    (working copy)

@@ -123,7 +123,8 @@

           @@formatter ||= Redcarpet::Markdown.new(

             Redmine::WikiFormatting::Markdown::HTML.new(

               :filter_html => true,

-              :hard_wrap => true

+              :hard_wrap => true,

+              :link_attributes => {:class => 'external'}

             ),

             :autolink => true,

             :fenced_code_blocks => true,

#3 - 2018-07-15 07:05 - Go MAEDA

- Subject changed from No "external" class when bare url is used in Markdown formatter to Bare URLs in Markdown don't have "external" class

Go MAEDA wrote:

The following patch fixes this issue.

 Unfortunately, it breaks some tests.

Failure:
ApplicationHelperTest#test_attachment_links_to_images_with_email_format_should_not_be_parsed [test/helpers/app

lication_helper_test.rb:709]:

Expected /<p><a class="attachment" href="\/attachments\/75">image@2x.png<\/a> should not be parsed in image@2x

.png<\/p>/ to match "<p><a class=\"attachment\" href=\"/attachments/75\">image@2x.png</a>\" class=\"external s

hould not be parsed in <a href=\"mailto:image@2x.png\" class=\"external\">image@2x.png</a></p>\n".

bin/rails test test/helpers/application_helper_test.rb:698

.................................F

Failure:

ApplicationHelperTest#test_user_links_with_email_as_login_name_should_not_be_parsed_markdown [test/helpers/app

lication_helper_test.rb:430]:

Expected /<p><a class=\"user active\".*>Bob Doe<\/a> should not be parsed in <a href=\"mailto:jsmith@somenet.f

oo\">jsmith@somenet.foo<\/a><\/p>/ to match "<p><a class=\"user active\" href=\"/users/14\">Bob Doe</a>\" clas

s=\"external should not be parsed in <a href=\"mailto:jsmith@somenet.foo\" class=\"external\">jsmith@somenet.f

oo</a></p>\n".

bin/rails test test/helpers/application_helper_test.rb:424

#4 - 2018-07-15 07:09 - Go MAEDA

- Target version deleted (Candidate for next minor release)

#5 - 2019-11-06 11:12 - Jan from Planio www.plan.io

- Related to Feature #32424: CommonMark Markdown Text Formatting added

#6 - 2021-08-12 09:22 - Go MAEDA

- Status changed from New to Closed

- Resolution set to Wont fix

The CommonMark formatter that will be available in Redmine 5.0.0 (#32424) correctly adds an "external" class. The existing RedCarpet based

Markdown formatter still has this bug, but I don't think we need to make any effort to fix it because it is going to be dropped in the near future.

#7 - 2023-08-31 10:38 - Go MAEDA

- Has duplicate Feature #39003: Add css class to external links in markdown added
